#ifndef _THERMODEVICES
#define _THERMODEVICES


#include "derivative.h" /* include peripheral declarations */
#include "PublicTypes.h"

/********************************************************************************************/
#define AVERAGE_QUANTITY 32

/********************************************************************************************/
void vfnLCD_PinMux_init (void);
void vfnLCD_print_value(unsigned int number);

void vfnInit_LEDs_IRQ(void);
void enable_irq (int irq);

void vfnDelay (unsigned long u32Delay);
void vfnThermocouple_init(void);
void vfnThermistor_init(void);
void vfnThermocouple_measuring(void);
void vfnThermistor_measuring(void);

void IRQ1_ISR (void);

/********************************************************************************************/
extern unsigned short temperature_result, temperature_measure, temp_measure_gain;
extern unsigned char selector;
extern unsigned char average_number; 
extern unsigned short temperature_average;

#endif //_THERMODEVICES

/********************************************************************************************/

